sets
i        /i1*i3/
t        /t1*t24/;

table    gdata(i,*)
         af         bf        cf         Pmax    Pmin
*        MBtu/MW2h  MBtu/MWh  MBtu/h     MW      MW
i1       0.0004     13.51     176.95     220     100
i2       0.001      32.63     129.97     100     10
i3       0.005      17.7      137.41     20      10
;
parameter load(t)
/
t1       227.747
t2       214.695
t3       206.271
t4       201.149
t5       201.578
t6       208.624
t7       225.407
t8       247.52
t9       267.228
t10      282.36
t11      297.193
t12      306.93
t13      314.834
t14      316.68
t15      323.518
t16      332.527
t17      332.8
t18      320.762
t19      332.8
t20      323.505
t21      313.456
t22      304.564
t23      308.399
t24      295.802
/;
parameter Psolar(t)
/
t1       0
t2       0
t3       0
t4       0
t5       8
t6       10
t7       12
t8       14
t9       15
t10      16
t11      18
t12      20
t13      25
t14      27
t15      27
t16      25
t17      20
t18      18
t19      10
t20      0
t21      0
t22      0
t23      0
t24      0
/;
parameter Qinlet(t)
/
t1       120
t2       21
t3       22
t4       23
t5       24
t6       25
t7       26
t8       27
t9       28
t10      29
t11      30
t12      31
t13      32
t14      33
t15      34
t16      35
t17      36
t18      37
t19      38
t20      39
t21      150
t22      41
t23      42
t24      43
/;
parameter Qoutlet(t)
/
t1       15
t2       16
t3       17
t4       18
t5       19
t6       20
t7       21
t8       22
t9       23
t10      24
t11      25
t12      26
t13      27
t14      28
t15      29
t16      30
t17      31
t18      32
t19      33
t20      34
t21      35
t22      36
t23      37
t24      38
/;
scalar
Price /50/
Ebini /10/
Gasprice /8/;

variable
Obj;
positive variables
P(i,t)
Pslr(t)
Pgrid(t)
Pch(t)
Pdch(t)
Eb(t)
Pchp(t)
Pbio(t)
Gbio(t);
binary variables
x(i,t);
equations eq1,eq2,eq3,eq4,eq5,eq6,eq7,eq8,eq9,eq10,eq11,eq12,eq13,eq14,eq15,eq16,eq17;
eq1..Obj=e=sum((t,i),gdata(i,'af')*power(P(i,t),2)+gdata(i,'bf')*P(i,t)+gdata(i,'cf')*x(i,t))+
           sum(t,Price*Pgrid(t))+
           sum(t,0.001*power(Pchp(t),2)+32.63*Pchp(t)+129.97)+
           sum(t,0.003*power(Pbio(t),2)+24.7*Pbio(t)+107.7);
eq2(t)..sum(i,P(i,t))+Pgrid(t)+Pslr(t)+Pchp(t)+Pbio(t)+Pdch(t)-Pch(t)=e=load(t);
eq3(i,t)..P(i,t)=l=gdata(i,'Pmax')*x(i,t);
eq4(i,t)..P(i,t)=g=gdata(i,'Pmin')*x(i,t);
eq5(t)..Pchp(t)=l=100;
eq6(t)..Pchp(t)=g=10;
eq7(t)..Pch(t)=l=15;
eq8(t)..Pch(t)=g=0;
eq9(t)..Pdch(t)=l=15;
eq10(t)..Pdch(t)=g=0;
eq11(t)..Eb(t)=l=50;
eq12(t)..Eb(t)=g=10;
eq13..Eb('t1')=e=Ebini+0.9*Pch('t1')-(Pdch('t1')/0.9);
eq14(t)$(ord(t)>1)..Eb(t)=e=Eb(t-1)+0.9*Pch(t)-(Pdch(t)/0.9);
eq15(t)..Gbio(t)=e=1.25*(Qinlet(t)-Qoutlet(t));
eq16(t)..Pbio(t)=e=0.6*Gbio(t);
eq17(t)..Pslr(t)=l=Psolar(t);
model MG /all/;
option MINLP=baron,optcr=0,optca=0;
solve MG using minlp minimizing Obj;
display Obj.l,Pslr.l,Pchp.l,Pbio.l,Pgrid.l,p.l,x.l,Pch.l,Pdch.l,Eb.l;




